//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: more_games.js
//  Description:
//       Author: Davidovich V. (ringo@g5software.com)
if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
      window.mozRequestAnimationFrame ||
      window.oRequestAnimationFrame ||
      window.msRequestAnimationFrame ||
      function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
        window.setTimeout( callback, 1000 / 60 );
      };
  })();
}

if (window.localStorage.getItem("xpromo") == null || window.localStorage.getItem("xpromo") == "test")
{
  window.localStorage.clear();
  window.localStorage.setItem("xpromo.platform", "iPhone");
  window.localStorage.setItem("xpromo",                "test");
  window.localStorage.setItem("xpromo.news.base",     "news.hd/");
  window.localStorage.setItem("xpromo.id",             "com.g5e.xpromoapp");
  window.localStorage.setItem("xpromo.games.self.id",  "com.g5e.xpromoapp.free");
  window.localStorage.setItem("xpromo.games.count",  "80");
  window.localStorage.setItem("xpromo.enable.affiliates",  "1");
  window.localStorage.setItem("xpromo.games.0.id",  "com.g5e.secretsociety.hd");
  window.localStorage.setItem("xpromo.games.1.id",  "com.g5e.virtualcitysb");
  window.localStorage.setItem("xpromo.games.2.id",  "com.g5e.bravetribe.hd");
  window.localStorage.setItem("xpromo.games.3.id",  "com.g5e.lettersfromnowherepg.hd");
  window.localStorage.setItem("xpromo.games.4.id",  "com.g5e.islandcastawaypg.hd");
  window.localStorage.setItem("xpromo.games.5.id",  "com.g5e.sofplayground.hd");
  window.localStorage.setItem("xpromo.games.6.id",  "com.g5e.hiddencity.hd");
  window.localStorage.setItem("xpromo.games.7.id",  "com.g5e.virtualcitysb.hd");
  window.localStorage.setItem("xpromo.games.8.id",  "com.g5e.dreamscapes");
  window.localStorage.setItem("xpromo.games.9.id",  "com.g5e.paranormal2.hd");
  window.localStorage.setItem("xpromo.games.10.id",  "com.g5e.abyss");
  window.localStorage.setItem("xpromo.games.11.id",  "com.g5e.alchemymysteries");
  window.localStorage.setItem("xpromo.games.12.id",  "com.g5e.wac");
  window.localStorage.setItem("xpromo.games.13.id",  "com.fgames.lsoul");
  window.localStorage.setItem("xpromo.games.14.id",  "com.g5e.specialenquiry2");
  window.localStorage.setItem("xpromo.games.15.id",  "com.g5e.whisperoffear");
  window.localStorage.setItem("xpromo.games.16.id",  "com.orchidgames.royaltrouble");
  window.localStorage.setItem("xpromo.games.17.id",  "com.g5e.carnival");
  window.localStorage.setItem("xpromo.games.18.id",  "com.realore.janeshotel2");
  window.localStorage.setItem("xpromo.games.19.id",  "com.g5e.specialenquiry");
  window.localStorage.setItem("xpromo.games.20.id",  "com.g5e.standofood3");
  window.localStorage.setItem("xpromo.games.21.id",  "com.g5e.rightkill2");
  window.localStorage.setItem("xpromo.games.22.id",  "com.g5e.letters2");
  window.localStorage.setItem("xpromo.games.23.id",  "com.g5e.treasures3");
  window.localStorage.setItem("xpromo.games.24.id",  "com.g5e.rcmlegion");
  window.localStorage.setItem("xpromo.games.25.id",  "com.g5e.smm");
  window.localStorage.setItem("xpromo.games.26.id",  "com.g5e.virtualcity2");
  window.localStorage.setItem("xpromo.games.27.id",  "com.g5e.inbetweenland");
  window.localStorage.setItem("xpromo.games.28.id",  "com.g5e.spiritwalkers");
  window.localStorage.setItem("xpromo.games.29.id",  "com.g5e.buildalot4");
  window.localStorage.setItem("xpromo.games.30.id",  "com.g5e.crystalportal2");
  window.localStorage.setItem("xpromo.games.31.id",  "com.g5e.mahjonga1");
  window.localStorage.setItem("xpromo.games.32.id",  "com.g5e.crossworlds");
  window.localStorage.setItem("xpromo.games.33.id",  "com.g5e.sm");
  window.localStorage.setItem("xpromo.games.34.id",  "com.g5e.pilotbr1");
  window.localStorage.setItem("xpromo.games.35.id",  "com.g5e.mahjonga2");
  window.localStorage.setItem("xpromo.games.36.id",  "com.g5e.youdasurvivor2");
  window.localStorage.setItem("xpromo.games.37.id",  "com.g5e.treasures1");
  window.localStorage.setItem("xpromo.games.38.id",  "com.g5e.jack");
  window.localStorage.setItem("xpromo.games.39.id",  "com.g5e.pilotbr2");
  window.localStorage.setItem("xpromo.games.40.id",  "com.g5e.letters");
  window.localStorage.setItem("xpromo.games.41.id",  "com.g5e.virtualcity");
  window.localStorage.setItem("xpromo.games.42.id",  "com.g5e.standofood");
  window.localStorage.setItem("xpromo.games.43.id",  "com.g5e.bigfoot");
  window.localStorage.setItem("xpromo.games.44.id",  "com.g5e.youdasurvivor");
  window.localStorage.setItem("xpromo.games.45.id",  "com.g5e.treasureseekers4");
  window.localStorage.setItem("xpromo.games.46.id",  "com.jetdogs.sinistercity");
  window.localStorage.setItem("xpromo.games.47.id",  "com.g5e.strix");
  window.localStorage.setItem("xpromo.games.48.id",  "com.g5e.rightkill1");
  window.localStorage.setItem("xpromo.games.49.id",  "com.g5e.crystalportal");
  window.localStorage.setItem("xpromo.games.50.id",  "com.g5e.isladorada");
  window.localStorage.setItem("xpromo.games.51.id",  "com.g5e.magicianbook2");
  window.localStorage.setItem("xpromo.games.52.id",  "com.g5e.builditmiami");
  window.localStorage.setItem("xpromo.games.53.id",  "com.g5e.fiu");
  window.localStorage.setItem("xpromo.games.54.id",  "com.g5e.redrumdd");
  window.localStorage.setItem("xpromo.games.55.id",  "com.g5e.fiu80");
  window.localStorage.setItem("xpromo.games.56.id",  "com.g5e.ts2");
  window.localStorage.setItem("xpromo.games.57.id",  "com.g5e.hiddenwonders");
  window.localStorage.setItem("xpromo.games.58.id",  "com.g5e.epiconboard");
  window.localStorage.setItem("xpromo.games.59.id",  "com.g5e.totemtribegold");
  window.localStorage.setItem("xpromo.games.60.id",  "com.bbb.mastersofmystery");
  window.localStorage.setItem("xpromo.games.61.id",  "com.bbb.mastersofmystery2");
  window.localStorage.setItem("xpromo.games.62.id",  "com.g5e.kbrawe");
  window.localStorage.setItem("xpromo.games.63.id",  "com.g5e.fiu2");
  window.localStorage.setItem("xpromo.games.64.id",  "com.g5e.ocr");
  window.localStorage.setItem("xpromo.games.65.id",  "com.g5e.spiritofwondering");
  window.localStorage.setItem("xpromo.games.66.id",  "com.g5e.paranormal");
  window.localStorage.setItem("xpromo.games.67.id",  "com.g5e.magicianbook");
  window.localStorage.setItem("xpromo.games.68.id",  "com.g5e.artmogul");
  window.localStorage.setItem("xpromo.games.69.id",  "com.g5e.shardsoftime");
  window.localStorage.setItem("xpromo.games.70.id",  "com.g5e.sstory");
  window.localStorage.setItem("xpromo.games.71.id",  "com.g5e.greenjelly");
  window.localStorage.setItem("xpromo.games.72.id",  "com.g5e.epiclajangada");
  window.localStorage.setItem("xpromo.games.73.id",  "com.kranx.yumsters2");
  window.localStorage.setItem("xpromo.games.74.id",  "com.g5e.xpromoapp");
  window.localStorage.setItem("xpromo.games.75.id",  "com.realore.janeshotel");
  window.localStorage.setItem("xpromo.games.76.id",  "com.g5e.mushroomage");
  window.localStorage.setItem("xpromo.games.77.id",  "com.g5e.buildalot3");
  window.localStorage.setItem("xpromo.games.78.id",  "com.g5e.romanceofrome");
  window.localStorage.setItem("xpromo.games.79.id",  "com.g5e.brightstonemysteries");
  window.localStorage.setItem("xpromo.recomend.count",  "4");
  window.localStorage.setItem("xpromo.recomend.0.id",  "com.g5e.secretsociety");
  window.localStorage.setItem("xpromo.recomend.1.id",  "com.g5e.virtualcitysb");
  window.localStorage.setItem("xpromo.recomend.2.id",  "com.g5e.twinmoons");
  window.localStorage.setItem("xpromo.recomend.3.id",  "com.g5e.islandcastaway2");
}

var userAgent = navigator.userAgent.toLowerCase();
var xpromoGames = xpromoGames || {};

var flagToStore = true,
    ifArr = {ios: false, ios4: false, itunes: false, android: false, nook: false},
    xpromoId,
    maxScrollX = 0,
    bigButton = bigButton || {"recent":null, "popular":null, "st_recent":null, "st_popular":null},
    platform,
    typesort = {"recent": {"sort":"rcnt", "type":"adv"}, "popular":{"sort":"pplr", "type":"adv"}, "st_recent":{"sort":"rcnt", "type":"st"}, "st_popular":{"sort":"pplr", "type":"st"}}
  ;

var bnArr = {'hrefFirst': '', 'cnt': 0};
var touchEvent = window.navigator.msPointerEnabled ? 'MSPointerDown' : 'touchstart';

for (var id in xpromoGames)
{
  try
  {
    var game  = xpromoGames[id];

    game.id   = id;
    game.date = new Date(game.date);

    if (!("doomed" in game))
      game.doomed = 0;
  }
  catch (e)
  {
    delete xpromoGames[id];
  }
}

var activeItem = 1;
var timerID    = 1;
var myScroll   = {"adv":null, "st":null};
var isIpadNew = isIpadNewFunc();

var mainGames = gamesInit(xpromoGames);
var flagFiltering = (mainGames.length < 5)? true : false;

var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
var BANNER_SITE = XPROMO_SITE + "news/";
var bannerDir = "news";

var bannerBase = window.localStorage.getItem("xpromo.news.base");
if (bannerBase)
{
  BANNER_SITE = XPROMO_SITE + bannerBase;
  if (bannerBase.indexOf('/') != -1)
    bannerDir = bannerBase.slice(0, bannerBase.indexOf('/'));
  else
    bannerDir = bannerBase;
}

mainGames = mainGames.filter(function(element, index, array) {
  // filter out duplicates
  for (var i = 0; i < index; i++)
    if (array[i].id == element.id)
      return false;

  // create store link
  if (!element.links)
    return false;

  if ("download" in element.links)
    element.href = element.links.download;
  else
  if ("free" in element.links)
    element.href = element.links.free;
  else
  if ("lite" in element.links)
    element.href = element.links.lite;
  else
  if ("full" in element.links)
    element.href = element.links.full;
  else
  if ("temp" in element.links)
    element.href = element.links.temp;
  else
    return false;

  if (new Date().getTime() < element.date.getTime()&&!("temp" in element.links && flagFiltering))
    return false;

  if (element.href.indexOf('javascript:') == -1)
  {
    if( element.links.hastrk3MG != undefined && element.links.hastrk3MG != "" )
    {
      element.href = convertLink("@ext(" + element.links.hastrk3MG + ")", "", "&sub_campaign=more_games");
    }
    else
    {
      element.href = convertLink("@ext(" + element.href + ")", element.links.hastrk3, "&sub_campaign=more_games");
    }
  }

  return true;
});

$(window).resize(function(){
  updateLayout();
}).load(function(){
  requestAnimationFrame(scrollGame);
});

$(document).bind('touchmove', function(e){
  e.preventDefault();
}).ready(function(){
  try{
    $('#exitButton, a.logo').on(touchEvent, function(e){
      var event = new Event('click', {bubbles: true, cancelable: true});
      e.target.dispatchEvent(event);
      return false;
    });

    platform = window.localStorage.getItem('xpromo.platform');
    xpromoId = gamesSelfId();

    if (!platform)
      platform = getPlatformFromId(xpromoId);
    platform = platform.toLowerCase();

    if (platform == 'android')
    {
      ifArr.android = true;

      window.addEventListener("popstate", function(e) {
        if(window.location.hash == "")
          window.location.href = "@exit";
      }, false);

      historyLog('more_games.html#next');
    }

    ifArr.ios = /iPhone|iPod|iPad/.test(navigator.userAgent);
    ifArr.nook = xpromoId.indexOf("nook") != -1;
    lockitRender();
    mainRender();
    if(platform == 'android')
    {
      for(var key in bigButton)
      {
        bigButton[key] = $("<div/>", {
          "class": "big-button",
          "data-type": typesort[key].type,
          "data-sort": typesort[key].sort,
          "data-typsort": key,
          "style": "width:"+ ($("#" + key).width()) +
            "px; height:" + ($(".table-cell").height()*1.8) +
            "px; top:" + ($("#" + key).offset().top - $(".table-cell").height() / 2) +
            "px; left:" + ($("#" + key).offset().left) + "px;"
        }).appendTo("body");
      }
      $('.big-button').on(touchEvent, changeType).on('mousedown', changeType);
    }

    updateLayout();
    bannerFirstRender();

    /*iPad 7_0_2 bug? correct width for iPhone version game running on the iPad(LFNII-970) */
    if (userAgent.indexOf("7_0_2") != -1 && userAgent.indexOf("ipad") != -1 && platform == "iphone")
      $('#global').width(window.innerWidth / (window.innerHeight / 768) + "px");

    var mouseWheel = true;
    if (platform == 'mac')
      mouseWheel = true;

    for(var key in myScroll)
    {
      myScroll[key] = new IScroll($p("." + key + " .games-box")[0], {
        scrollX:true,
        scrollY:false,
        mouseWheel: mouseWheel,
        tap: false,
        click: true,
        horizontalScroll: function(_stage, _startX, _direction, _currentX) {
          switch(_stage)
          {
            case 'move':
              flagToStore = false;
              break;
            case 'end':
              setTimeout(function(){flagToStore = true;}, 1000);
              break;
          }
        }
      });
      myScroll[key].on('scrollEnd', function () {
        flagToStore = true;
      });
    }

    maxScrollX = Math.max(myScroll["adv"].maxScrollX, myScroll["st"].maxScrollX, -1500);
    myScroll["adv"].scrollTo(maxScrollX, 0, 0);
    myScroll["st"].scrollTo(maxScrollX, 0, 0);

    $('.games-box').on('click', 'a', function(event){
      if (flagToStore)
      {
        flagToStore = false;
        setTimeout(function(){flagToStore = true;}, 1500);
        return true;
      }
      else
      {
        return false;
      }
    });

    //bannersFetch();

    getCountryLang();

  }catch(e) {
    //
  }
});

function mainRender()
{
  var data = {},
    gamesBox;

  var gamesDirective =
  {
    "li" :
    {
      "game<-games" :
      {
        "a@href" : "game.href",
        ".name" : "game.name_short",
        ".icon@style" : function(arg) {
          return iconStyleFor(arg.item.id, 3);
        },
        ".icon@src" : function(arg) {
          return arg.item.id + "/" + iconNameFor(arg.item.id)
        },
        ".icon@alt_img" : function(arg) {
          if (isIpadNew)
            return arg.item.id;
          return '';
        }
      }
    }
  };

  mainGames = replaceSort(mainGames, false);
  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'st' || element.genre == 'both');});
  gamesBox = $p(".st .games-box-hidden ul.pplr");
  gamesBox.autoRender(data, gamesDirective);
  if (gamesBox[0].childElementCount > 0)
  $('.st .type-game span').append(' (' + gamesBox[0].childElementCount + ')');

  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'adv' || element.genre == 'both');});
  gamesBox = $p(".adv .games-box-hidden ul.pplr");
  gamesBox.autoRender(data, gamesDirective);
  if (gamesBox[0].childElementCount > 0)
  $('.adv .type-game span').append(' (' + gamesBox[0].childElementCount + ')');

  mainGames = replaceSort(mainGames, true);
  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'st' || element.genre == 'both');});
  gamesBox = $p(".st .games-box-hidden ul.rcnt");
  gamesBox.autoRender(data, gamesDirective);
  data.games = mainGames.slice(0);
  data.games = data.games.filter(function(element){return (element.genre == 'adv' || element.genre == 'both');});
  gamesBox = $p(".adv .games-box-hidden ul.rcnt");
  gamesBox.autoRender(data, gamesDirective);

  var index = 1;
  if (typeof window['getActiveTab'] == 'function')
    index = getActiveTab('mg');

  $('.adv .select-type a').removeClass('selected').eq(index).addClass('selected');
  gamesBox = $p(".adv .games-box ul");
  gamesBox[0].innerHTML = $p(".adv .games-box-hidden ul")[1-index].innerHTML;

  $('.st .select-type a').removeClass('selected').eq(index).addClass('selected');
  gamesBox = $p(".st .games-box ul");
  gamesBox[0].innerHTML = $p(".st .games-box-hidden ul")[1-index].innerHTML;

  $('.select-type a').on(touchEvent, changeType).on('mousedown', changeType);
}

function changeType(e)
{
  if (e.type.toLowerCase() != 'mousedown')
  {
    e.preventDefault();
    e.stopPropagation();
  }
  var th = $(this);
  var tp = th.attr('data-sort');
  var _type = th.attr('data-type');
  $("."+_type+" .select-type a").removeClass('selected');
  if (th.attr('data-typsort'))
    $("#"+th.attr('data-typsort')).addClass('selected');
  th.addClass('selected');
  var gamesBox = $p("."+_type+" .games-box ul");
  var donor = $p("."+_type+" .games-box-hidden ul." + tp);
  gamesBox[0].innerHTML  = donor[0].innerHTML;
  myScroll[_type].scrollTo(0, 0, 0);
  myScroll[_type].refresh();
  myScroll[_type].scrollTo(0, 0, 0);
}

function updateLayout()
{
  var zoom = (window.innerHeight / 768) * 100;
  document.body.style.zoom = zoom + "%";
  if (userAgent.indexOf("trident") != -1)
  {
    (Math.floor(zoom) == 101 || Math.floor(zoom) == 99)? document.body.style.width = window.innerWidth + "px" :
      document.body.style.width = document.documentElement.clientWidth*100/Math.floor(zoom) + "px" ;
  }
  else
  if (userAgent.indexOf("android 4") == -1)
  {
    document.body.style["font-size"] = document.body.style.zoom;
  }

  var gamesBox = $p(".st .games-box ul");
  gamesBox = $p(".adv .games-box ul");

  for(var key in myScroll)
  {
    if (myScroll[key])
      myScroll[key].refresh();
  }
  if(platform == 'android')
  {
    for(var key in bigButton)
    {
      bigButton[key].css({
        "width": $("#" + key).width() + 'px',
        "height": $(".table-cell").height()*1.8 + 'px',
        "top": $("#" + key).offset().top - $(".table-cell").height() / 2 + 'px',
        "left": $("#" + key).offset().left + 'px'
      });
    }
  }
  if (window.innerHeight > window.innerWidth)
  {
    $('body').addClass('portrait-orientation');
  }
  else
  {
    $('body').removeClass('portrait-orientation');
  }
}

function scrollGame()
{
  for(var key in myScroll)
  {
    if (myScroll[key])
    {
      if (myScroll[key].maxScrollX < 0)
      {
        setTimeout(function(key){
          return function(){
            myScroll[key].scrollTo(0, 0, 4000);
          }
        }(key), 1000);
      }
    }
    // todo SMMII-464
    if (userAgent.indexOf("trident") != -1)
    {
      var gamesBox = $p("."+key+" .games-box ul");
      var donor = $p("."+key+" .games-box-hidden ul.pplr");
      gamesBox[0].innerHTML  = donor[0].innerHTML;
    }
  }
}

/*
* From Games.js
*
*/

function gamesInit(_table)
{
  var games = new Array(parseInt(window.localStorage.getItem("xpromo.games.count")));
  for (var i = 0; i < games.length; i++)
    games[i] = gamesLoadGame(_table, window.localStorage.getItem("xpromo.games." + i + ".id"));
  // filter unavailable games
  var self_id = window.localStorage.getItem("xpromo.games.self.id");
  if (null == self_id)
    self_id = window.localStorage.getItem("xpromo.id");
  games = games.filter(function(element){
    return element != null && element.id != self_id;
  });

  return games;
}

function gamesLoadGame(_table, _id)
{
  //TODO: check this code laters
  var lockit = lockitLoad(_id + "/index");
  if (!lockit)
  {
    console.log("not found: " + _id);
    return null;
  }
  var game = _table[_id];
  if (!game)
  {
    game = {};
    game.id = _id;
  }
  var bundle = game.id.split('.').slice(0, 3).join('.');
  game.name       = lockit["title"];
  game.name_short = lockit["title_short"] || game.name;
  game.name_short = $("<p>" + game.name_short + "</p>").text();
  game.links      = lockit["#links"];
  //game.genre      = lockit["genre"].toLowerCase();
  game.genre      = 'adv';
  if (typeof xpromoGenre == 'object')
  {
    if (typeof xpromoGenre[bundle] != 'undefined')
      game.genre = xpromoGenre[bundle].toLowerCase();
  }
  game.slogan     = lockit["#slogan"] || ""; //add for new GF
  if (!_table[_id])
    _table[_id] = game;
  if (lockit['target_lang'])
  {
    var target_lang = lockit['target_lang'];
    target_lang = target_lang.toLowerCase();
    target_lang = target_lang.split('|');
    if (target_lang.indexOf(lockit['lang'].toLowerCase()) == -1)
      return null;
    var country_lang = window.localStorage.getItem('country_lang');
    if (country_lang != null)
    {
      country_lang = country_lang.toLowerCase();
      country_lang = country_lang.split('|');
      var flag = false;
      for (var b in target_lang)
      {
        if (country_lang.indexOf(target_lang[b]) != -1)
        {
          flag = true;
          break;
        }
      }
      if (!flag)
        return null;
    }
    else
    {
      return null;
    }
  }
  return game;
}

function replaceSort(arr, flag)
{
  var arr_doomed, arr_middle, arr_top;
  arr_doomed = arr.filter(function(element, index, array){
    return (element.doomed < 0);
  });
  if (flag)
  {
    arr_doomed.sort(function(a, b){
      return b.date - a.date;
    });
  }
  if (flag)
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed == 0);
    });
    arr_middle.sort(function(a, b) {
      return b.date - a.date;
    });
    arr_top = arr.filter(function(element, index, array){
      return (element.doomed > 0);
    });
    arr_top.sort(function(a, b) {
      return b.date - a.date;
    });
    var ret = new Array();
    var i;
    for (var b in arr_top)
    {
      i = arr_top[b].doomed - 1;
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_top[b];
    }
    i = 0;
    for (var b in arr_middle)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_middle[b];
    }
    for (var b in arr_doomed)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_doomed[b];
    }
  }
  else
  {
    arr_middle = arr.filter(function(element, index, array){
      return (element.doomed > -1);
    });
    var ret = arr_middle.concat(arr_doomed);
  }
  return ret;
}

/*
* banners fetch
*/
function bannersFetch()
{
  var bannerRequest = new XMLHttpRequest();
  bannerRequest.open("GET", BANNER_SITE + "banners.txt", true);
  bannerRequest.onreadystatechange = function(){
    if (this.readyState != 4)
      return;

    var text;
    if (this.status == 200 || this.responseText) // for local GET to work
    {
      text = this.responseText;
      getBanners(JSON.parse(text));
    }
    else
    {
      var t = document.createElement("script");
      t.src = XPROMO_SITE + 'service/get_banners.php?bannerDir=' + bannerDir + "&bannerFile=banners.txt&functionName=getBanners";
      t.onerror = function(){
        getBanners(getBannersFromStorage());
      };
      document.body.appendChild(t);
    }
  }
  bannerRequest.send(null);
}

function getBannersFromStorage() {
  var content = window.localStorage.getItem('xpromo.banners');
  if (content != null)
    return JSON.parse(content);
  return lockitLoadLangs(bannerDir + '/banners');
}

function getBanners(text, _flag) {
  _flag = !_flag;
  if (_flag)
    window.localStorage.setItem("xpromo.banners", JSON.stringify(text));
  var xpromoBanners = null;
  if (text)
    xpromoBanners = lockitGet(text);
  //xpromoBanners = lockitGet(JSON.parse(text));

  var data = {};
  data.banners = lockitThis.banners;
  if (xpromoBanners)
    data.banners = xpromoBanners.banners.concat(data.banners);

  var timeNow = new Date().getTime();

  data.banners = data.banners.filter(function(element, index, array)
  {
    if (element.begsAt)
    {
      var begsAt = new Date(element.begsAt);
      if (timeNow < begsAt.getTime())
        return false;
    }

    if (element.endsAt)
    {
      var endsAt = new Date(element.endsAt);
      if (timeNow >= endsAt.getTime())
        return false;
    }

    var self_id = gamesSelfId();
    if (element.includes)
    {
      var arrIncludes = element.includes.split('|');
      if(!inArray(self_id, arrIncludes))
        return false;
    }

    if (element.excludes)
    {
      var arrExcludes = element.excludes.split('|');
      if(inArray(self_id, arrExcludes) != false)
        return false;
    }

    if(element.hastrk3MG != undefined && element.hastrk3MG != "")
    {
      element.href = convertLink(element.hastrk3MG, "", "&sub_campaign=more_games");
    }
    else
    {
      element.href = convertLink(element.href, element.hastrk3, "&sub_campaign=more_games");
    }

    return true;
  });
  if (_flag)
    bannersRender(data);
  return data;
}

var bannerDirective = {
  "@id" : function(arg) {
    return "banner-item-" + (arg.context.pos + 1);
  },
  "@href" : "href",
  "@data-xpromoid"  : function(arg) {
    if (arg.context.icon)
      return arg.context.icon.split('/')[0];
    else
    if (arg.context.style)
      return arg.context.style.split('/')[1].split('.')[0] + ".png";
    else
      return "else.lp";
  },
  "@style" : function(arg) {
    var result = "";
    if (arg.context.pos != 0)
      result += "display:none;";
    if (arg.context.style)
      result += arg.context.style;
    return result;
  },
  ".icon@style" : function(arg) {
    if (arg.context.icon)
    {
      var tmp = arg.context.icon;
      var pos = tmp.indexOf('/');
      if(pos != -1)
      {
        tmp = tmp.substring(0, pos);
        var platform = '';
        var img = 'icon.jpg';
        for (var i in mainGames)
        {
          if (mainGames[i]['id'] == tmp)
          {
            platform = getPlatformFromId(mainGames[i]['id']);
            if (platform == 'mac')
              img = 'icon.png';
            return "background-image: url('" + mainGames[i]['id'] + "/" + img + "')" + iconStyleFor(mainGames[i]['id'], 3);
          }
        }
        var bundle = tmp.split('.');
        bundle = bundle[2];
        for (var i in mainGames)
        {
          tmp = mainGames[i]['id'].split('.');
          tmp = tmp[2];
          if (bundle == tmp)
          {
            platform = getPlatformFromId(mainGames[i]['id']);
            if (platform == 'mac')
              img = 'icon.png';
            return "background-image: url('" + mainGames[i]['id'] + "/" + img + "')" + iconStyleFor(mainGames[i]['id'], 3);
          }
        }
        tmp = arg.context.icon.substring(0, pos);
        return "background-image: url('" + XPROMO_SITE + arg.context.icon + "')" + iconStyleFor(tmp, 3);
      }
    }
    return "display:none;";
  },
  ".icon@alt_img" : function(arg) {
    if (arg.context.icon && isIpadNew)
    {
      var tmp = arg.context.icon;
      var pos = tmp.indexOf('/');
      if(pos != -1)
        return tmp.substring(0, pos);
    }
    return '';
  },
  ".icon@class"     : function(arg) {
    if (arg.context.icon)
    {
      var game_id = arg.context.icon;
      game_id = game_id.split('/');
      game_id = game_id[0];
      var platform = getPlatformFromId(game_id);
      return "icon icon_" + platform;
    }
    return "icon";
  },
  "div.text" : "text",
  "@data-img" : function(arg) {
    if (arg.context.style)
    {
      var tmp = arg.context.style;
      var needle = 'url(';
      var pos = tmp.indexOf(needle);
      if (pos > -1)
      {
        tmp = tmp.substr(pos + needle.length);
        pos = tmp.indexOf(')');
        if (pos > -1)
        {
          tmp = tmp.substr(0, pos);
          tmp = tmp.replace(/\'/g, '');
          tmp = tmp.replace(/\"/g, '');
          tmp = tmp.split('.');
          tmp[tmp.length - 2] += '_win';
          return tmp.join('.');
        }
      }
    }
    return '';
  },
  ".+" : function(arg) {
    return arg.context.button ? ("<div class='button'><span>" + arg.context.button + "</span></div>") : "";
  }
};
function bannerFirstRender () {
  var bannerBase = window.localStorage.getItem("xpromo.news.base");
  if (bannerBase)
  {
    bannerBase = bannerBase.split('/');
    bannerDir = bannerBase[0];
  }
  bnArr.bannerBox = $('.banners-box');
  bnArr.hiddenBox = $('.hidden-box');
  bnArr.hiddenBox.html(bnArr.bannerBox.html());
  bnArr.compiled = bnArr.hiddenBox.find('.banner-item').compile(bannerDirective);
  var content = '';
  var _data = getBannersFromStorage();
  if (typeof _data == 'object')
  {
    _data = getBanners(_data, true);
    if (_data.banners.length > 0)
    {
      _data.banners[0].pos = bnArr.cnt;
      bnArr.cnt++;
      bnArr.hrefFirst = _data.banners[0].href;
      content = bnArr.compiled(_data.banners[0]);
      bnArr.bannerBox.html(content);
      //fixBanner();
    }
  }
  setTimeout(bannersFetch, 4000);
}
function bannersRender(_data) {
  if (bnArr.cnt == 0)
  {
    bnArr.bannerBox.html('');
  }
  else
  {
    _data.banners = _data.banners.filter(function (element) {
      if (element.href == bnArr.hrefFirst)
        return false;
      return true;
    });
  }
  var content = '';
  for (var i in _data.banners)
  {
    _data.banners[i].pos = bnArr.cnt;
    bnArr.cnt++;
    content = bnArr.compiled(_data.banners[i]);
    bnArr.bannerBox.append(content);
  }
  setTimeout(function(){
    scrollerByTimeOut();
  }, 3000);
  if (isIpadNew)
    preloadBigImage();
  var userAgent = navigator.userAgent.toLowerCase();
  if (userAgent.indexOf("trident") != -1)
    bannerWin();
}

/*
*
* */
function preloadBigImage()
{
  var arr_load = new Array();
  var tmp;
  $('div.latest-games .icon').each(function()
  {
    tmp = $(this).attr('alt_img');
    if (getPlatformFromId(tmp) == 'ipad')
    {
      if (!inArray(tmp, arr_load))
        arr_load.push(tmp);
    }
  });
  if (arr_load.length > 0)
  {
    var img = document.createElement('img');
    $(img).bind('load', function()
    {
      $('div.icon[alt_img="' + arr_load[0] + '"]').css('background-image', 'url(' + XPROMO_SITE + arr_load[0] + '/icon-big.jpg?v=1)').removeAttr('alt_img');
      $('img.icon[alt_img="' + arr_load[0] + '"]').attr('src', XPROMO_SITE + arr_load[0] + '/icon-big.jpg?v=1').removeAttr('alt_img');
      arr_load.shift();
      if (arr_load[0])
        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg?v=1';
    });
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg?v=1';
  }
}

/*
 *
 * */
function scrollerByTimeOut()
{
  var nextItem = (activeItem >= $('#global .banners-box .banner-item').length) ? 1 : activeItem + 1;
  scroller(nextItem);
}

function scroller(aId)
{
  if (activeItem != aId)
  {
    $('#banner-item-' + activeItem).fadeOut(500);
    $('#banner-item-' + aId).fadeIn(500);
    activeItem = aId;
  }

  clearTimeout(timerID);
  timerID = setTimeout(function ()
  {
    scrollerByTimeOut()
  }, 10000);
}
/*
*
* */
function historyLog(_link)
{
  var supportsHistoryAPI=!!(window.history && history.pushState);
  if (ifArr.android && supportsHistoryAPI)
  {
    window.history.pushState(null, null, _link);
  }
  else
  {
    window.location.href = _link;
  }
}

function gamesSelfId()
{
  var result = window.localStorage.getItem("xpromo.games.self.id");
  if (null == result)
    result = window.localStorage.getItem("xpromo.id");

  return result;
}
/*
* Game Navigator
* */
function showPlatform()
{
 $('#platform').show();
}

function bannerWin() {
  var allA = $('.banners-box a');
  var arr = [];
  var el;
  for (var i = 0; i < allA.length; i++)
  {
    el = allA.eq(i);
    if (el.attr('data-img'))
      arr.push(el.attr('data-img'));
  }
  if (arr.length > 0)
  {
    function setWinBanner(_name) {
      var image = new Image();
      image.onload = function() {
        allA.filter("[data-img='" + _name + "']").each(function() {
          $(this).css('background-image', 'none').find('div.icon').css('background-image', 'url(' + _name + ')').addClass('icon_mac').show();
        });
      }
      image.src = _name;
    }
    for (var i in arr)
    {
      setWinBanner(arr[i]);
    }
  }
}
