//-------------------------------------------------------------------
//
//  This code is copyright 2014 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: more_games.js
//  Description:
//       Author: Voronoy S. (sergey.voronoy@g5e.com)

var userAgent = navigator.userAgent.toLowerCase()

$(document).bind('touchmove', function(e){
  e.preventDefault();
}).ready(function(){
  loadDefault('more_games', function(){
    lockitLang = lockitGetLang();
    updateLayout();
    $(window).resize(function(){updateLayout();});
    window.xpromoId = gamesSelfId();
    lockitLoadLangs(document.title, function(_data){
      _data = lockitRenderData(_data);
      globalRender();
    }, true);
  });
});

function globalRender() {
  var cnt = window.localStorage.getItem('xpromo.games.counts');
  if (!cnt)
    cnt = 0;
  console.log(cnt);
}

function updateLayout() {
  var zoom = (window.innerHeight / 768) * 100;
  document.body.style.zoom = zoom + "%";
  if (userAgent.indexOf("trident") != -1)
  {
    (Math.floor(zoom) == 101 || Math.floor(zoom) == 99)? document.body.style.width = window.innerWidth + "px" :
      document.body.style.width = document.documentElement.clientWidth*100/Math.floor(zoom) + "px" ;
  }
  else
  if (userAgent.indexOf("android 4") == -1)
  {
    document.body.style["font-size"] = document.body.style.zoom;
  }
}
